#version 330


uniform sampler2D colorTexture;
uniform sampler2DShadow shadowMap;
uniform float innercone;
uniform float outercone;

in vec3 lightDirection_cameraspace;
in vec2 fUVs;
in vec3 position_worldspace;
in vec3 normal_cameraspace;
in vec3 vertexToLight_cameraspace;
in vec3 lightDir;
in vec4 LightSpacePos_out;
 
//shadowmapping attr
in vec4 ShadowCoord;

out vec4 fragColor;


  float CalcShadowFactor(vec4 LightSpacePos)
{
    /*vec3 ProjCoords = LightSpacePos.xyz / LightSpacePos.w;
    vec2 UVCoords;
    UVCoords.x = 0.5 * ProjCoords.x + 0.5;
    UVCoords.y = 0.5 * ProjCoords.y + 0.5;
    float z = 0.5 * ProjCoords.z + 0.5;
    */return textureProj(shadowMap, ShadowCoord);
    //if (Depth < (z + 0.00001))
    //    return 0.5;
    //else
    //    return 1.0;
}


void main()
{

    
  vec3 LightColor = vec3(1,1,1);
	float LightPower = 2.0f;
	float distance = length( LightSpacePos_out.xyz - position_worldspace );
	float atten = 1/(0.5 + 0.5*distance + 0.5*distance*distance);//max(0.0, 1.0 - dot(vertexToLight_cameraspace, vertexToLight_cameraspace));
	
	//vec3 MaterialDiffuseColor = texture2D(colorTexture, fUVs ).rgb;
	//vec3 MaterialAmbientColor  = vec3(0.3,0.3,0.3);
  //MaterialAmbientColor = MaterialAmbientColor * MaterialDiffuseColor;
  //vec3 MaterialSpecularColor = vec3(0.3,0.3,0.3);
  
  //vec4 texel = texture(colorTexture, fUVs);
  
  
  vec3 n = normalize(normal_cameraspace);
  vec3 l = normalize(vertexToLight_cameraspace);
  
  vec3 V = normalize(-position_worldspace);
	vec3 R = normalize(-reflect(l, n));
	
  float nDotL = max(0.0, dot(n, l));
  float rDotV = max(0.0, dot(R, V));
  
  vec3 matAmb = vec3(texture( colorTexture, fUVs).rgb);
	vec3 matDiff = vec3(0.3,0.3,0.3);
	vec3 matSpec = vec3(0.3,0.3,0.3);
  
  vec3 spotAmb= vec3(0.3,0.3,0.3);
	vec3 spotDiff= vec3(1,1,1);
	vec3 spotSpec= vec3(1,1,1);
  
  //normalize vector from vertex to light
  vec3 d = normalize(lightDirection_cameraspace);
  
  //Rho i
  float cosAlpha = dot(-l, d);
  
  //cos(phi/2)
  float cosPhiHalbe = cos(radians(/*60.0*/outercone)/2.0);
  
  //cos(theta/2)
  float cosThetaHalbe = cos(radians(/*20.0*/innercone)/2.0);
  
  float intensity = pow( (cosAlpha - cosPhiHalbe) / (cosThetaHalbe - cosPhiHalbe), 1 );
  intensity = clamp( intensity, 0,1 );
  
  
  atten *= intensity;
  float shininess = 0.2;
  
  vec3 ambient = spotAmb * matAmb ;
	vec3 diffuse = spotDiff  * matDiff * nDotL ;
	vec3 specular = spotSpec * matSpec * pow(rDotV, shininess) ;
	vec3 texel = texture(colorTexture, fUVs).rgb;
	
	/*if(intensity<0.5f){
		intensity=0.5f;
	}*/
	
	float shade = CalcShadowFactor(LightSpacePos_out);
	/*if(shade<0.5f){
		shade=0.5f;
	}*/
	
	fragColor.rgb = ambient +( diffuse + specular)  *texel * intensity * shade;// CalcShadowFactor(LightSpacePos_out);
  
  	fragColor.a = 0.3;
}  
  
  
  
  
  
  
  
  
  
 
  
  
  
  
  
  /*
    for(int i=0; i<4; i++){
    int index = i;
		//visibility -= 0.5*(1.0-texture( shadowMap, vec3(ShadowCoord.xy + poissonDisk[index]/700.0,  (ShadowCoord.z-bias)/ShadowCoord.w) ));
    
    //if ( texture( shadowMap, (ShadowCoord.xy/ShadowCoord.w) ).z  <  (ShadowCoord.z-bias)/ShadowCoord.w ){
			//visibility-= 0.2*(1.0 - (texture( shadowMap, (ShadowCoord.xy+ poissonDisk[index]/700.0) ).z ) );
			//visibility-= 0.5*(1.0 - (texture( shadowMap, (ShadowCoord.xy/ShadowCoord.w) ).z ) );
			//visibility=0.5;
		//}
	}
  
  
  
  
  
  //vertex within inner cone
  if(cosAlpha > cosThetaHalbe ){
   
     for(int i=0; i<4; i++){
      int index = i;
      visibility -= 0.2*(1.0-texture( shadowMap, vec3(ShadowCoord.xy + poissonDisk[index]/700.0,  (ShadowCoord.z-bias)/ShadowCoord.w) ));
    }
    fragColor = vec3(0,1,0)*visibility*intensity;
  }
  
  // vertex within outer cone;
  else if (cosAlpha > cosPhiHalbe){
     
     // vertex within outer cone but out of inner cone;
    if(cosAlpha < cosThetaHalbe){
      for(int i=0; i<4; i++){
      int index = i;
      visibility -= 0.2*(1.0-texture( shadowMap, vec3(ShadowCoord.xy + poissonDisk[index]/700.0,  (ShadowCoord.z-bias)/ShadowCoord.w) ));
    }
      fragColor = vec3(0,0,1)*visibility*intensity;
    }
    
  }  
  else{
    fragColor = vec3(1,0,0)*intensity;
  }

  */
