	#version 330

	uniform vec3 LightSpacePos;
	uniform mat4 modelMatrix;
	uniform mat4 viewMatrix;
	uniform mat4 projectionMatrix;
	uniform vec3 lightDirection;
  uniform mat4 gLightWVP;
  
  //shadowmapping attr
  uniform mat4 DepthBiasMVP;
  out vec4 ShadowCoord;
  
	in vec3 position_modelspace;
	in vec3 normal_modelspace;
	in vec2 uv;

	out vec2 fUVs;
	out vec3 position_worldspace;
	out vec3 normal_cameraspace;
	out vec3 vertexToLight_cameraspace;
	out vec3 lightDirection_cameraspace;
  out vec4 LightSpacePos_out; 
  
	void main()
	{
    mat4 modelViewMatrix = viewMatrix * modelMatrix;
    mat4 mvpMatrix = projectionMatrix * modelViewMatrix;
    vec4 pos = vec4(position_modelspace.x, position_modelspace.y, position_modelspace.z, 1.0);
    gl_Position = mvpMatrix * pos;
  
    pos = modelViewMatrix * pos;
    position_worldspace = pos.xyz / pos.w;
  
  
    pos = viewMatrix * vec4(LightSpacePos, 1.0);
  
    vec3 spotlightPosEye = pos.xyz / pos.w;
    vertexToLight_cameraspace = (spotlightPosEye - position_worldspace) ;
  
    lightDirection_cameraspace = vec3(viewMatrix * vec4(lightDirection, 0.0));
      
    // Normal des vertex, in kamerakoordinaten
    normal_cameraspace = ( viewMatrix * modelMatrix * vec4(normal_modelspace,0)).xyz; 
  
    // UV des vertex.
    fUVs = uv;
    
    
    ShadowCoord = DepthBiasMVP * vec4(position_modelspace,1);
    
		LightSpacePos_out = gLightWVP * vec4(position_modelspace, 1.0);
	}






























/*
		//position von dem vertex als vec4 in clippingspace zurueckgeben aus der matrix
		gl_Position =  mvpMatrix * vec4(position,1);
		
		// position von dem vertex in weltkoordinaten
		position_worldspace = (modelMatrix * vec4(position,1)).xyz;
		
		// vec. von dem Vertex zu der kamera in kamerakoordinaten
		// eye-vector die zu der kamera schaut ist die kameraposition (da die kamera in (0,0,0) in 
	kamerakoordinaten sich befindet)-vertexposition
		
		vec3 vertexPosition_cameraspace = ( viewMatrix * modelMatrix * vec4(position,1)).xyz;
		
		//vec3 EyeDirection_cameraspace = vec3(0,0,0) - vertexPosition_cameraspace;
		
		// vec. von dem Vertex zu dem licht in kamerakoordinaten
		
		vec3 LightPosition_cameraspace = ( modelViewMatrix * vec4(lightPosition,1)).xyz/lightPosition.w;
		lightDirection_cameraspace = ( modelViewMatrix * vec4(lightDirection,1)).xyz;
		
		//lightDirection_cameraspace = (LightPosition_cameraspace + EyeDirection_cameraspace);
		
		
		vec3 vertexToLight = (LightPosition_cameraspace - vertexPosition_cameraspace);
		vertexToLight_cameraspace = vertexToLight;
		*/
		















		
		